package gonganxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type photo struct {
	Table
	order  string `data:"95"`
	fields string `data:"space_id,access_token,expire_time,vendor"`
	remove string `name:"remove" role:"worker"`
	upload string `name:"upload" role:"worker"`
	trash  string `name:"trash" role:"worker"`
}

func (s photo) Config(m *ice.Message, arg ...string) {
	s.InsertOrUpdate(m, arg, m.OptionSimple(model.PLACE_UID)...)
}
func (s photo) List(m *ice.Message, arg ...string) {
	s.cmdy(m, PhotoVendor.Folder, kit.Slice(arg, 1)...)
	m.PushAction(s.Trash).Action(s.Upload).Display("")
	if m.Result() == "" {
		s.Button(m, "请上传文件", s.Upload)
	}
}
func (s photo) Upload(m *ice.Message, arg ...string) { s.cmdy(m, "") }
func (s photo) Trash(m *ice.Message, arg ...string)  { s.cmdy(m, "") }

func init() { ice.TeamCtxCmd(photo{Table: newTable()}) }

func (s photo) cmdy(m *ice.Message, action ice.Any, arg ...string) {
	const SPACE_ID = "space_id"
	if m.Option(model.AUTH_UID, s.StreetAuthUID(m, m.Option(s.PLACE_UID))) == "" {
		return
	}
	if msg := s.Select(m.Spawn(), model.PLACE_UID, m.Option(s.PLACE_UID)); msg.Append(SPACE_ID) == "" {
		m.Echo("本服务暂未配置，请联系公司管理员配置")
	} else {
		kit.If(action == "", func() { action = m.ActionKey() })
		m.Option(model.PLACE_UID, m.Option(s.PLACE_UID))
		_msg := m.Cmd(msg.Append(model.VENDOR), PhotoVendor.Token, msg.Append(SPACE_ID), msg.Append(model.ACCESS_TOKEN), msg.Append(model.EXPIRE_TIME))
		m.Cmdy(msg.Append(model.VENDOR), action, m.Option(model.AUTH_UID), msg.Append(SPACE_ID), _msg.Append(model.ACCESS_TOKEN), arg)
	}
}

var PhotoVendor interface {
	Folder(m *ice.Message, arg ...string)
	Upload(m *ice.Message, arg ...string)
	Trash(m *ice.Message, arg ...string)
	Token(m *ice.Message, arg ...string)
}
